// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package com.hatimonline.code.roosec.web.admin;

import com.hatimonline.code.roosec.domain.SystemUser;
import java.io.UnsupportedEncodingException;
import java.lang.Long;
import java.lang.String;
import java.util.Collection;
import javax.annotation.PostConstruct;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.joda.time.format.DateTimeFormat;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.core.convert.converter.Converter;
import org.springframework.core.convert.support.GenericConversionService;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect SystemUserController_Roo_Controller {
    
    @Autowired
    private GenericConversionService SystemUserController.conversionService;
    
    @RequestMapping(method = RequestMethod.POST)
    public String SystemUserController.create(@Valid SystemUser systemUser, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("systemUser", systemUser);
            addDateTimeFormatPatterns(model);
            return "admin/systemusers/create";
        }
        systemUser.persist();
        return "redirect:/admin/systemusers/" + encodeUrlPathSegment(systemUser.getId().toString(), request);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String SystemUserController.createForm(Model model) {
        model.addAttribute("systemUser", new SystemUser());
        addDateTimeFormatPatterns(model);
        return "admin/systemusers/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String SystemUserController.show(@PathVariable("id") Long id, Model model) {
        addDateTimeFormatPatterns(model);
        model.addAttribute("systemuser", SystemUser.findSystemUser(id));
        model.addAttribute("itemId", id);
        return "admin/systemusers/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String SystemUserController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            model.addAttribute("systemusers", SystemUser.findSystemUserEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) SystemUser.countSystemUsers() / sizeNo;
            model.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            model.addAttribute("systemusers", SystemUser.findAllSystemUsers());
        }
        addDateTimeFormatPatterns(model);
        return "admin/systemusers/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String SystemUserController.update(@Valid SystemUser systemUser, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("systemUser", systemUser);
            addDateTimeFormatPatterns(model);
            return "admin/systemusers/update";
        }
        systemUser.merge();
        return "redirect:/admin/systemusers/" + encodeUrlPathSegment(systemUser.getId().toString(), request);
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String SystemUserController.updateForm(@PathVariable("id") Long id, Model model) {
        model.addAttribute("systemUser", SystemUser.findSystemUser(id));
        addDateTimeFormatPatterns(model);
        return "admin/systemusers/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String SystemUserController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        SystemUser.findSystemUser(id).remove();
        model.addAttribute("page", (page == null) ? "1" : page.toString());
        model.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/admin/systemusers?page=" + ((page == null) ? "1" : page.toString()) + "&size=" + ((size == null) ? "10" : size.toString());
    }
    
    @RequestMapping(params = { "find=ByUsername", "form" }, method = RequestMethod.GET)
    public String SystemUserController.findSystemUsersByUsernameForm(Model model) {
        return "admin/systemusers/findSystemUsersByUsername";
    }
    
    @RequestMapping(params = "find=ByUsername", method = RequestMethod.GET)
    public String SystemUserController.findSystemUsersByUsername(@RequestParam("username") String username, Model model) {
        model.addAttribute("systemusers", SystemUser.findSystemUsersByUsername(username).getResultList());
        return "admin/systemusers/list";
    }
    
    @ModelAttribute("systemusers")
    public Collection<SystemUser> SystemUserController.populateSystemUsers() {
        return SystemUser.findAllSystemUsers();
    }
    
    Converter<SystemUser, String> SystemUserController.getSystemUserConverter() {
        return new Converter<SystemUser, String>() {
            public String convert(SystemUser systemUser) {
                return new StringBuilder().append(systemUser.getTimeCreated()).append(" ").append(systemUser.getTimeLastModified()).append(" ").append(systemUser.getPassword()).toString();
            }
        };
    }
    
    @PostConstruct
    void SystemUserController.registerConverters() {
        conversionService.addConverter(getSystemUserConverter());
    }
    
    void SystemUserController.addDateTimeFormatPatterns(Model model) {
        model.addAttribute("systemUser_timecreated_date_format", DateTimeFormat.patternForStyle("SS", LocaleContextHolder.getLocale()));
        model.addAttribute("systemUser_timelastmodified_date_format", DateTimeFormat.patternForStyle("SS", LocaleContextHolder.getLocale()));
    }
    
    private String SystemUserController.encodeUrlPathSegment(String pathSegment, HttpServletRequest request) {
        String enc = request.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
